Attribute VB_Name = "Centipede"
Public CharImage(0 To 4096) As Byte
Public WarpCharSet(0 To 16384) As Byte
Public Const HISCORE_BYTES = &H2F
Public Const RAM_HISCORES = &H2
Public Const ROM_HISCORES = &H3A69
Public game As String

Public SPRITE_OFFSET As Integer
Public SPRITE_XPOS As Integer
Public SPRITE_YPOS As Integer
Public SCREEN_MEM As Integer

Public viewpic As Byte

Public KEY_ESC As Byte
Public KEY_3 As Byte
Public KEY_2 As Byte
Public KEY_1 As Byte
Public KEY_CTRL As Byte
Public KEY_UP As Byte
Public KEY_LEFT As Byte
Public KEY_DOWN As Byte
Public KEY_RIGHT As Byte

Public VirtualScreen(2, 256, 256) As Byte

Public Function Main()
  Dim test As Long
  Dim vx As Integer, vy As Integer
  game = "centipede"
  'Clear all keycodes
  KEY_ESC = 0
  KEY_3 = 0
  KEY_2 = 0
  KEY_1 = 0
  KEY_CTRL = 0
  KEY_UP = 0
  KEY_LEFT = 0
  KEY_DOWN = 0
  KEY_RIGHT = 0
  
  'Set first virtual screen
  viewpic = 1
  
  'Define Parameters in Centipede
  SPRITE_OFFSET = &H7C0
  SPRITE_XPOS = &H7D0
  SPRITE_YPOS = &H7E0
  SCREEN_MEM = &H400
  AddressMask = &H3FFF
  
  'Clear the virtualscreens
  'For vx = 0 To 256
  '  For vy = 0 To 256
  '    VirtualScreen(1, vx, vy) = 0
  '    VirtualScreen(2, vx, vy) = 0
  '    'And the real screen
  '    Arcade.ArcadeScreen.PSet (vx, vy), RGB(0, 0, 0)
  '  Next vy
  'Next vx
  Arcade.ArcadeScreen.BackColor = &H0

  'Clear rom area
  For test = 0 To 65536
    gameImage(test) = 0
  Next test
  For test = 0 To 4096
    CharImage(test) = 0
  Next test
  'Load the roms
  loadchar "136001.211", 0
  loadchar "136001.212", 2048
  loadrom "136001.307", 8192 + 0
  loadrom "136001.308", 8192 + 2048
  loadrom "136001.309", 8192 + 4096
  loadrom "136001.310", 8192 + 4096 + 2048
  
  'Turn the service mode off
  gameImage(&HC00) = &H60
  
  'Implement Hack protection
  gameImage(&H38A8) = &HEA
  gameImage(&H38A9) = &HEA
  gameImage(&H38AE) = &HEA
  gameImage(&H38AF) = &HEA
    
  'Dipswitch Settings...
  put6502memory &H800, 0
  put6502memory &H801, 0
      
  WarpChars

'  VirBMP = CreateCompatibleBitmap(arcade.ArcadeScreen.hdc, 255, 255)
'  lbBits = GlobalAlloc(0, 256& * 500&)
'  GetBitmapBits VirBMP, 255& * 255&, lbBits
  
  init6502
  reset6502
  
  
End Function

Public Function loadrom(filename As String, startadress As Long)
  Dim i As Long
  If FileLen(App.Path & "\" & filename) <= 0 Then
    MsgBox "Place ROMs in the same directory as the executable"
    End
  End If
  Open App.Path & "\" & filename For Binary Access Read As #1
  
  For i = startadress To startadress + FileLen(filename)
    Get #1, , gameImage(i)
    Next i
  Close #1

End Function

Public Function loadchar(filename As String, startadress As Integer)
  Dim i As Integer
  If FileLen(App.Path & "\" & filename) <= 0 Then
    MsgBox "Place ROMs in the same directory as the executable"
    End
  End If
  Open App.Path & "\" & filename For Binary Access Read As #1
  For i = startadress To startadress + FileLen(filename)
    Get #1, , CharImage(i)
    Next i
  Close #1

End Function

Public Function WarpChars()
  Dim x As Integer, cx As Integer, cy As Integer, bit As Integer
  Dim result As Byte
  Dim count As Integer
  count = 0
  For cy = 0 To 7
    For cx = 0 To 31
      For bit = 7 To 0 Step -1
        For x = 0 To 7
          result = 0
          If GetBit(bit + (x * 8) + (cx * 64) + (cy * 2048)) Then result = 1
          If GetBit(bit + (x * 8) + (cx * 64) + (cy * 2048) + 16384) Then result = result Xor 2
          WarpCharSet(count) = result
          count = count + 1
        Next x
      Next bit
    Next cx
  Next cy
End Function

Public Function GetBit(startbit As Integer) As Integer
  Dim nbyte As Integer
  Dim nbit As Integer
  Dim mask As Integer
  
  nbyte = startbit \ 8
  nbit = startbit Mod 8
  mask = &H80
  mask = mask \ 2 ^ nbit
  
  If (CharImage(nbyte) And mask) = mask Then
    GetBit = 1
  Else
    GetBit = 0
  End If
End Function

Public Function RedrawScreen()
  Dim x As Integer, y As Integer, count As Integer
  Dim xpos As Integer
  Dim ypos As Integer
  Dim offset As Integer
  Dim tid As Double
  Dim sluttid As Double
  Dim cx As Integer
  Dim cy As Integer
  Dim start As Integer
  Dim hdc As Integer
  Dim x1 As Integer
  Dim y1 As Integer
  Dim col As Long
  tid = Timer
  Dim virx As Integer, viry As Integer
  Dim char As Byte
  Dim add As Byte
  count = 0
  'Draw chars
  For x = 0 To 29
    For y = 31 To 0 Step -1
      If game = "centipede" Then
        DrawSingleChar gameImage(SCREEN_MEM + count) + 64, x, y, 0
        count = count + 1
      ElseIf game = "millipede" Then
        char = gameImage(SCREEN_MEM + count) And &H3F
        add = 64
        If (gameImage(SCREEN_MEM + count) And &H40) Then add = 192
        DrawSingleChar char + add, x, y, 0
        count = count + 1
      End If
    Next y
  Next x
  
  'Draw sprites
  For x = 0 To 15
    xpos = gameImage(SPRITE_XPOS + x)
    ypos = gameImage(SPRITE_YPOS + x)
    offset = gameImage(SPRITE_OFFSET + x)
    
    If (ypos < &HF8) Then
      drawsprite offset, xpos, ypos
    End If
  Next x
  
  If viewpic = 0 Then
    For virx = 0 To 256
      For viry = 0 To 256
        If VirtualScreen(0, virx, viry) = VirtualScreen(1, virx, viry) Then
        Else
          Arcade.ArcadeScreen.PSet (virx, viry), QBColor(VirtualScreen(0, virx, viry))
          VirtualScreen(1, virx, viry) = VirtualScreen(0, virx, viry)
        End If
      Next viry
    Next virx
  End If
  
  If viewpic = 1 Then
    For virx = 0 To 256
      For viry = 0 To 256
        If VirtualScreen(0, virx, viry) = VirtualScreen(1, virx, viry) Then
        Else
          Arcade.ArcadeScreen.PSet (virx, viry), QBColor(VirtualScreen(1, virx, viry))
          VirtualScreen(0, virx, viry) = VirtualScreen(1, virx, viry)
        End If
      Next viry
    Next virx
  End If
  
  Arcade.ArcadeScreen.Refresh
  Arcade.ArcadeScreen.Visible = True
  If viewpic = 0 Then
    viewpic = 1
  Else
    viewpic = 0
  End If

End Function
  
Public Function DrawSingleChar(CharNo As Integer, x As Integer, y As Integer, palette As Integer)
  Dim cx As Integer
  Dim cy As Integer
  Dim start As Integer
  Dim hdc As Integer
  Dim x1 As Integer
  Dim y1 As Integer
  x1 = x * 8
  y1 = y * 8
  start = CharNo * 64
    
'  hdc = arcade.ArcScreen(viewpic).hdc
  For cy = y1 To y1 + 7
    For cx = x1 To x1 + 7
       VirtualScreen(viewpic, cx, cy) = WarpCharSet(start) 'Or (palette * 2 ^ 2)
 '     SetPixel hdc, cx, cy, QBColor(WarpCharSet(start))
      start = start + 1
    Next cx
  Next cy
  'End With
End Function

Public Function drawsprite(offset As Integer, x As Integer, y As Integer)
  Dim cx As Integer, cy As Integer, start As Integer
  Dim SpOffset As Integer
  Dim Flip As Integer
  Dim ypos As Byte, xpos As Byte
  Dim hdc As Integer
  
  SpOffset = (offset And &H3E)
  Flip = 1
  start = SpOffset * 64
  
  If (offset And &H1) = &H1 Then start = start + 8192
  If (offset And &H80) = &H80 Then Flip = 0
    
'  hdc = arcade.ArcScreen(viewpic).hdc
  
  For cy = 7 To 0 Step -1
    For cx = 0 To 7
      ypos = 255 - (y + cy)
      If (Flip) Then
        If (238 - (x - cx)) < 0 Then
          xpos = (256 + 238) - (x - cx)
        Else
          xpos = 238 - (x - cx)
        End If
        If WarpCharSet(start) = 0 Then
        Else
          If xpos < &HF0 Then
            VirtualScreen(viewpic, xpos, ypos) = WarpCharSet(start)
          End If
        End If
        
        If WarpCharSet(start + 64) = 0 Then
        Else
          If (xpos + 8) < &HF0 Then
            VirtualScreen(viewpic, xpos + 8, ypos) = WarpCharSet(start + 64)
'            SetPixel hdc, xpos + 8, ypos, QBColor(WarpCharSet(start + 64))
          End If
        End If
      Else
        If 238 - (x - (8 - cx)) < 0 Then
          xpos = 256 + 238 - (x - (8 - cx))
        Else
          xpos = 238 - (x - (8 - cx))
        End If
        If WarpCharSet(start) = 0 Then
        Else
          If (xpos + 8) < &HF0 Then
            VirtualScreen(viewpic, xpos + 8, ypos) = WarpCharSet(start)
'            SetPixel hdc, xpos + 8, ypos, QBColor(WarpCharSet(start))
          End If
        End If
        If WarpCharSet(start + 64) = 0 Then
        Else
          If (xpos < &HF0) Then
            VirtualScreen(viewpic, xpos, ypos) = WarpCharSet(start + 64)
'            SetPixel hdc, xpos, ypos, QBColor(WarpCharSet(start + 64))
          End If
        End If
      End If
      start = start + 1
    Next cx
  Next cy

End Function

Public Function DisplayCharSet()
  Dim x As Integer
  Dim y As Integer
  For x = 0 To 31
    For y = 0 To 7
      DrawSingleChar (y * 32) + x, x, y, 0
    Next y
  Next x
  For x = 0 To 256
    For y = 0 To 256
        Arcade.ArcadeScreen.PSet (x, y), QBColor(VirtualScreen(viewpic, x, y))
    Next y
  Next x
  Arcade.ArcadeScreen.Refresh
End Function
Sub LoadStatus()
If FileLen(App.Path & "\centi.sav") > 0 Then
Open App.Path & "\centi.sav" For Binary Access Read As #2
    For i = 0 To HISCORE_BYTES
        Get #2, , gameImage(ROM_HISCORES + i)
    Next i
    i = HISCORE_BYTES + 1
    Get #2, i, gameImage(&H800)
    Get #2, i + 1, gameImage(&H801)
Close #2
End If
End Sub
Sub SaveStatus()

End Sub
