Attribute VB_Name = "M6502AddrModes"
'Greatly modified by Tobias Strmstedt in march 1998.
'Implemented Interrupt support
'Correct address masking
'Random numbers
'Full support of all addressing modes
'Bug corrections

' My 2nd try at a 6502 emulator. This one is based on Neil Bradley's
' 6502 C source. I don't like Marat's because it's slower...
' This emulator features all 6502 addressing modes. Also
' all 157 6502 OpCodes are supported.
' The emulator is *VERY* buggy still and the addressing modes
' are called at the wrong times.
' This was written for all the Visual Basic programmers that
' want to write a CPU emulator but don't know where to start.
' I didn't write most of this, it was written by some guy, and the
' source was used in EMU by Neil Bradley. Thanks for donating this
' Neil =).

Public AddressMask As Integer

'Registers and tempregisters
Public A As Byte
Public x As Byte
Public y As Byte
Public F As Byte
Public S As Byte
Public P As Byte
Public PC As Long
Public savepc As Long
Public value As Byte
Public sum As Integer, saveflags As Integer
Public help As Integer

Global Const IPeriod = 26500
Public Const DEBUGGING = 0

Public opcode As Byte
Public clockticks6502 As Long
Public TimerTicks As Long

' arrays
Public TICKS(0 To 256) As Integer
Public addrmode(0 To 256)
Public instruction(0 To 256)
Public gameImage(0 To 65536) As Byte

Public TrapBadOps As Integer  ' Quit emulation when OpCode is invalid...
Public CPUPaused As Integer  ' Is the CPU Paused
Public CPURunning As Integer ' Is the CPU running?
Public ROMLoaded As Integer  ' Is a Game loaded?
Public Trace As Integer      ' Print Current OpCode?

Public Function implied6502()
  
End Function

Public Function indabsx6502()
  help = gameImage(PC) + (gameImage(PC + 1) * 256) + x
  savepc = gameImage(help) + (gameImage(help + 1) * 256)
End Function
Public Function indx6502()
'TS: Changed PC++ and removed '(?)
  value = (gameImage(PC) + x) And &HFF
  PC = PC + 1
  savepc = gameImage(value) + (gameImage(value + 1) * 2 ^ 8)
End Function
Public Function indy6502()
'TS: Changed PC++ and == to != (If then else)
  value = gameImage(PC)
  PC = PC + 1
      
  savepc = gameImage(value) + (gameImage(value + 1) * 2 ^ 8)
  If (TICKS(opcode) = 5) Then
    If ((savepc \ 2 ^ 8) = ((savepc + y) \ 2 ^ 8)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + y
End Function

Public Function zpx6502()
'TS: Rewrote everything!
'Overflow stupid check
  savepc = gameImage(PC)
  savepc = savepc + x
  PC = PC + 1
  savepc = savepc And &HFF
End Function

Public Function exec6502()
  'TS: Implemented game randomizer
  If CPURunning = 1 Then
  TimerTicks = TimerTicks + 1
  If game = "centipede" Then
  If (TimerTicks And 7) = 1 Then
    gameImage(&H100A) = Int((255 * Rnd) + 1)
  End If
  End If
  opcode = gameImage(PC)  ' Fetch Next Operation
  PC = PC + 1
  
  clockticks6502 = clockticks6502 + TICKS(opcode)
  
  Select Case opcode
    Case &H9D: sta6502
    Case &H29: and6502
    Case &HB5: lda6502
    Case &H90: bcc6502
    Case &H10: bpl6502
    Case &HD0: bne6502
    Case &H85: sta6502
    Case &HF0: beq6502
    Case &HC9: cmp6502
    Case &HCA: dex6502
    Case &H45: eor6502
    Case &HB0: bcs6502
    Case &H20: jsr6502
    Case &H60: rts6502
    Case &HA5: lda6502
    Case &H46: lsr6502
    Case &HA0: ldy6502
    Case &H18: clc6502
    Case &HA9: lda6502
    Case &H65: adc6502
    Case &HE0: cpx6502
    Case &H95: sta6502
    Case &H9A: txs6502
    Case &HAD: lda6502
    Case &HE8: inx6502
    Case &HA4: ldy6502
    Case &HA8: tay6502
    Case &H38: sec6502
    Case &H98: tya6502
    Case &H9: ora6502
    Case &H91: sta6502
    Case &H4C: jmp6502
    Case &HA6: ldx6502
    Case &HB4: ldy6502
    Case &H69: adc6502
    Case &HB1: lda6502
    Case &H88: dey6502
    Case &H8C: sty6502
    Case &HC0: cpy6502
    Case &HE5: sbc6502
    Case &HE6: inc6502
    
    Case &H5: ora6502
    Case &H8: php6502
    Case &HA: asla6502
    Case &H19: ora6502
    Case &H1A: ina6502
    Case &H1B: nop6502
    Case &H1C: trb6502
    Case &H1D: ora6502
    Case &H1E: asl6502
    Case &H1F: nop6502
    Case &H21: and6502
    Case &H22: nop6502
    Case &H23: nop6502
    Case &H24: bit6502
    Case &H25: and6502
    Case &H26: rol6502
    Case &H27: nop6502
    Case &H28: plp6502
    Case &H2A: rola6502
    Case &H2B: nop6502
    Case &H2C: bit6502
    Case &H2D: and6502
    Case &H2E: rol6502
    Case &H2F: nop6502
    Case &H30: bmi6502
    Case &H31: and6502
    Case &H32: and6502
    Case &H33: nop6502
    Case &H34: bit6502
    Case &H35: and6502
    Case &H36: rol6502
    Case &H37: nop6502
    Case &H39: and6502
    Case &H3A: dea6502
    Case &H3B: nop6502
    Case &H3C: bit6502
    Case &H3D: and6502
    Case &H3E: rol6502
    Case &H3F: nop6502
    Case &H40: rti6502
    Case &H41: eor6502
    Case &H42: nop6502
    Case &H43: nop6502
    Case &H44: nop6502
    Case &H47: nop6502
    Case &H48: pha6502
    Case &H49: eor6502
    Case &H4A: lsra6502
    Case &H4B: nop6502
    Case &H4D: eor6502
    Case &H4E: lsr6502
    Case &H4F: nop6502
    Case &H50: bvc6502
    Case &H51: eor6502
    Case &H52: eor6502
    Case &H53: nop6502
    Case &H54: nop6502
    Case &H55: eor6502
    Case &H56: lsr6502
    Case &H57: nop6502
    Case &H58: cli6502
    Case &H59: eor6502
    Case &H5A: phy6502
    Case &H5B: nop6502
    Case &H5C: nop6502
    Case &H5D: eor6502
    Case &H5E: lsr6502
    Case &H5F: nop6502
    Case &H61: adc6502
    Case &H62: nop6502
    Case &H63: nop6502
    Case &H64: stz6502
    Case &H66: ror6502
    Case &H67: nop6502
    Case &H68: pla6502
    Case &H6A: rora6502
    Case &H6B: nop6502
    Case &H6C: jmp6502
    Case &H6D: adc6502
    Case &H6E: ror6502
    Case &H6F: nop6502
    Case &H70: bvs6502
    Case &H71: adc6502
    Case &H72: adc6502
    Case &H73: nop6502
    Case &H74: stz6502
    Case &H75: adc6502
    Case &H76: ror6502
    Case &H77: nop6502
    Case &H78: sei6502
    Case &H79: adc6502
    Case &H7A: ply6502
    Case &H7B: nop6502
    Case &H7C: jmp6502
    Case &H7D: adc6502
    Case &H7E: ror6502
    Case &H7F: nop6502
    Case &H80: bra6502
    Case &H81: sta6502
    Case &H82: nop6502
    Case &H83: nop6502
    Case &H84: sty6502
    Case &H86: stx6502
    Case &H87: nop6502
    Case &H89: bit6502
    Case &H8A: txa6502
    Case &H8B: nop6502
    Case &H8D: sta6502
    Case &H8E: stx6502
    Case &H8F: nop6502
    Case &H92: sta6502
    Case &H93: nop6502
    Case &H94: sty6502
    Case &H96: stx6502
    Case &H97: nop6502
    Case &H99: sta6502
    Case &H9B: nop6502
    Case &H9C: stz6502
    Case &H9E: stz6502
    Case &H9F: nop6502
    Case &HA1: lda6502
    Case &HA2: ldx6502
    Case &HA3: nop6502
    Case &HA7: nop6502
    Case &HAA: tax6502
    Case &HAB: nop6502
    Case &HAC: ldy6502
    Case &HAE: ldx6502
    Case &HAF: nop6502
    Case &HB2: lda6502
    Case &HB3: nop6502
    Case &HB6: ldx6502
    Case &HB7: nop6502
    Case &HB8: clv6502
    Case &HB9: lda6502
    Case &HBA: tsx6502
    Case &HBB: nop6502
    Case &HBC: ldy6502
    Case &HBD: lda6502
    Case &HBE: ldx6502
    Case &HBF: nop6502
    Case &HC1: cmp6502
    Case &HC2: nop6502
    Case &HC3: nop6502
    Case &HC4: cpy6502
    Case &HC5: cmp6502
    Case &HC6: dec6502
    Case &HC7: nop6502
    Case &HC8: iny6502
    Case &HCB: nop6502
    Case &HCC: cpy6502
    Case &HCD: cmp6502
    Case &HCE: dec6502
    Case &HCF: nop6502
    Case &HD1: cmp6502
    Case &HD2: cmp6502
    Case &HD3: nop6502
    Case &HD4: nop6502
    Case &HD5: cmp6502
    Case &HD6: dec6502
    Case &HD7: nop6502
    Case &HD8: cld6502
    Case &HD9: cmp6502
    Case &HDA: phx6502
    Case &HDB: nop6502
    Case &HDC: nop6502
    Case &HDD: cmp6502
    Case &HDE: dec6502
    Case &HDF: nop6502
    Case &HE1: sbc6502
    Case &HE2: nop6502
    Case &HE3: nop6502
    Case &HE4: cpx6502
    Case &HE7: nop6502
    Case &HE9: sbc6502
    Case &HEA: nop6502
    Case &HEB: nop6502
    Case &HEC: cpx6502
    Case &HED: sbc6502
    Case &HEE: inc6502
    Case &HEF: nop6502
    Case &HF1: sbc6502
    Case &HF2: sbc6502
    Case &HF3: nop6502
    Case &HF4: nop6502
    Case &HF5: sbc6502
    Case &HF6: inc6502
    Case &HF7: nop6502
    Case &HF8: sed6502
    Case &HF9: sbc6502
    Case &HFA: plx6502
    Case &HFB: nop6502
    Case &HFC: nop6502
    Case &HFD: sbc6502
    Case &HFE: inc6502
    Case &HFF: nop6502
    Case &H0: brk6502
    Case &H1: ora6502
    Case &H2: nop6502
    Case &H3: nop6502
    Case &H4: tsb6502
    Case &H6: asl6502
    Case &H7: nop6502
    Case &HB: nop6502
    Case &HC: tsb6502
    Case &HD: ora6502
    Case &HE: asl6502
    Case &HF: nop6502
    Case &H11: ora6502
    Case &H12: ora6502
    Case &H13: nop6502
    Case &H14: trb6502
    Case &H15: ora6502
    Case &H16: asl6502
    Case &H17: nop6502
    
    Case Else: MsgBox "Illegal opcode"
  End Select
  If clockticks6502 >= 9000 Then '(CYCLES_PER_INTERRUPT)
    clockticks6502 = 0
    If (P And &H4) = 0 Then
      irq6502
    End If
  End If
  End If
End Function
Public Function indzp6502()
'Added pc=pc+1, and (value+1) (Why Don?)
  value = gameImage(PC)
  PC = PC + 1
  savepc = gameImage(value) + (gameImage(value + 1) * 2 ^ 8)
End Function

Public Function zpy6502()
'TS: Added PC=PC+1
      savepc = gameImage(PC) + y
      PC = PC + 1
      savepc = savepc And &HFF
End Function

Public Function absy6502()
'TS: Changed to != instead of == (Look at absx for more details)
  savepc = gameImage(PC) + (gameImage(PC + 1) * 256&)
  PC = PC + 1
  PC = PC + 1
  If (TICKS(opcode) = 4) Then
    If ((savepc \ 2 ^ 8) = ((savepc + y) \ 2 ^ 8)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + y
End Function

Public Function get6502memory(addr As Long) As Byte
  Dim valc01 As Byte, valc03 As Byte
  If game = "centipede" Then
  'Is it reading the input ports?
  Select Case addr
    Case &HC01:
      valc01 = &HFF
      
      If KEY_3 = 1 Then
        valc01 = valc01 Xor &H40
      End If
      
      If KEY_1 = 1 Then
        valc01 = valc01 Xor &H1
      End If
      
      If KEY_CTRL = 1 Then
        valc01 = valc01 Xor &H4
      End If
      
      gameImage(&HC01) = valc01

    Case &HC03
      valc03 = &HFF
      If KEY_UP = 1 Then
        valc03 = valc03 Xor &H10
      End If
      If KEY_DOWN = 1 Then
        valc03 = valc03 Xor &H20
      End If
      If KEY_LEFT = 1 Then
        valc03 = valc03 Xor &H40
      End If
      If KEY_RIGHT = 1 Then
        valc03 = valc03 Xor &H80
      End If
      gameImage(&HC03) = valc03
  End Select
  get6502memory = gameImage(addr And AddressMask)
ElseIf game = "millipede" Then
    get6502memory = MilliRd(addr)
ElseIf game = "asteroids" Then
    get6502memory = AsterRd(addr)
End If
End Function
Public Function immediate6502()
  savepc = PC
  PC = PC + 1
End Function
Public Function indirect6502()
  help = gameImage(PC) + (gameImage(PC + 1) * 256)
  savepc = gameImage(help) + (gameImage(help + 1) * 256)
  PC = PC + 1
  PC = PC + 1
End Function

Public Function absx6502()
'TS: Changed to if then else instead of if then (!= instead of ==)
  savepc = gameImage(PC)
  savepc = savepc + (gameImage(PC + 1) * 256)
  PC = PC + 1
  PC = PC + 1
  If (TICKS(opcode) = 4) Then
    If ((savepc \ 2 ^ 8) = ((savepc + x) \ 2 ^ 8)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + x
End Function
Public Function put6502memory(addr As Long, byte1 As Byte)
  If game = "centipede" Then
  If (addr <= &HFF) Then
    If byte1 > 0 Then
      addr = addr
    End If
  End If
  If addr = &H1800 Then
    clockticks6502 = 0
  End If
     
  If addr >= &H2000 Then
    Exit Function
  End If

  gameImage(addr) = byte1
  ElseIf game = "millipede" Then
    put6502memory = MilliWr(addr, byte1)
  End If
End Function
Public Function abs6502()
  savepc = gameImage(PC) + (gameImage(PC + 1) * 256)
  PC = PC + 1
  PC = PC + 1
End Function
Public Function relative6502()
'Changed to PC++ and == to != (If then else)
  savepc = gameImage(PC)
  PC = PC + 1

  If (savepc And &H80) Then savepc = savepc - &H100
  If ((savepc \ 2 ^ 8) = (PC \ 2 ^ 8)) Then
  Else
    clockticks6502 = clockticks6502 + 1
  End If
  End Function

Public Function reset6502()
  A = 0: x = 0: y = 0: P = 0
  P = P Or &H20
  S = &HFF
  PC = gameImage(65532 And AddressMask)
  PC = PC Or (gameImage(65533 And AddressMask) * 2 ^ 8)
End Function

Public Function zp6502()
  savepc = gameImage(PC)
  PC = PC + 1
End Function

Public Function irq6502()
   ' Maskable interrupt
   xx& = put6502memory(&H100 + S, ((PC \ 2 ^ 8) And &HFF))
   S = S - 1
   xx& = put6502memory(&H100 + S, (PC And &HFF))
   S = S - 1
   xx& = put6502memory(&H100 + S, P)
   S = S - 1
   P = P Or &H4
   PC = get6502memory(65534 And AddressMask)
   PC = PC Or get6502memory(65535 And AddressMask) * 2 ^ 8
End Function

Public Function nmi6502()
'TS: Changed PC>>8 to / not *
  xx& = put6502memory(&H100 + S, (PC \ 2 ^ 8))
  S = S - 1
  xx& = put6502memory(&H100 + S, (PC And 255))
  S = S - 1
  xx& = put6502memory(&H100 + S, P)
  P = P Or &H4
  PC = get6502memory(65530 And AddressMask)
  PC = PC Or get6502memory(65531 And AddressMask) * 2 ^ 8
End Function
